<template>
  <div v-loading="loading" class="detail-container relative flex flex-col flex-auto h-full w-full pt-6 lg:pt-12">
<!--    <Button-->
<!--      :icon="isCollapsed ? 'pi pi-chevron-left' : 'pi pi-chevron-right'"-->
<!--      severity="secondary"-->
<!--      plain-->
<!--      class="hidden button-collapse shadow-md !border-0 !rounded-lg"-->
<!--      @click="toggleCollapse"></Button>-->
    <div v-if="detail" class="flex-shrink-0 flex flex-col lg:items-start px-4 lg:pl-12 lg:pr-12">
      <div class="flex flex-wrap items-stretch lg:pl-0">
        <Button
          :size="isMobile ? 'mini' : 'small'"
          outlined
          class="button-back"
          @click="backToList">
          Zurück zur Suche
        </Button>

        <Button
          :disabled="disablePrevious"
          :size="isMobile ? 'mini' : 'small'"
          icon="pi pi-angle-double-left"
          :label="isMobile ? '' : 'Voriger Eintrag'"
          outlined
          class="button-back"
          @click="next(detail.gsnId, -1)">
        </Button>

         <Button
           :disabled="disableNext"
           :size="isMobile ? 'mini' : 'small'"
           icon="pi pi-angle-double-right"
           iconPos="right"
           :label="isMobile ? '' : 'Nächster Eintrag'"
           outlined
           class="button-back"
          @click="next(detail.gsnId, 1)">
         </Button>
        <div class="ml-auto">
          <Popover
            v-if="isMobile"
            placement="top-start"
            popper-class="ld-tooltip"
            width="80">
            <div v-if="isMobile" class="flex flex-col text-sm space-y-2 text-right">
              <a :href="getLinkedDataURL('jsonld')" target="_blank">JSON-LD</a>
              <a :href="getLinkedDataURL('turtle')" target="_blank">Turtle</a>
              <a :href="getLinkedDataURL('rdfxml')" target="_blank">RDF/XML</a>
            </div>
            <i slot="reference" class="el-icon-more text-2xl"></i>
          </Popover>
        </div>
      </div>
      <div class="flex flex-col lg:flex-row lg:flex-wrap w-full mb-4 lg:mb-2">
        <h2 class="mt-4 lg:mt-6 lg:mb-2">{{detail.name}}</h2>
        <div v-if="!isMobile" class="flex items-center space-x-2 text-sm ml-4 lg:ml-auto lg:text-base ">
          <a :href="getLinkedDataURL('jsonld')" target="_blank">JSON-LD</a>
          <a :href="getLinkedDataURL('turtle')" target="_blank">Turtle</a>
          <a :href="getLinkedDataURL('rdfxml')" target="_blank">RDF/XML</a>
        </div>
        <div class="flex w-full lg:mb-6 italic text-gray-500" v-if="detail.altLabels.length > 0">
          (<span v-for="(altLabel, i) in detail.altLabels" :key="i">
<!--          <Tag :value="altLabel.lang" severity="secondary" class="uppercase !bg-gray-500 !text-gray-100 !leading-4 mr-2" />-->
          <span>{{altLabel.label}}</span><span class="mr-1" v-if="i < detail.altLabels.length - 1">;</span>
        </span>)
        </div>
      </div>
    </div>
    <div class="body lg:flex flex-col overflow-y-auto pr-2 lg:pr-8 lg:pl-8 pl-4 pt-4 border-t border-t-gray-300" v-if="detail && !loading">
        <ContentCard title="Empfohlene Zitierweise">
          <p>"{{detail.name}}" (GSN: {{detail.gsnId}}), in: Germania Sacra, {{citeUrl}} (Abgerufen am {{today}})</p>
        </ContentCard>

        <ContentCard title="Patrozinium">
          <p>{{detail.patrocinium ? detail.patrocinium : '-'}}</p>
        </ContentCard>

        <!-- Locations -->
        <ContentCard title="Lage">
          <div class="flex flex-col">
            <div :class="{'mb-2': i < detail.locations.length - 1}" v-for="(location, i) in detail.locations" :key="location.geonames_id">
              <span>{{location.from}}&ndash;{{location.to}} {{location.placeName}}</span>
              <span v-if="location.locationName"> ({{location.locationName}})</span>,
              {{location.countryName}}, {{ renderCoordinates(location) }},
              <span class="font-bold">Bistum/Erzbistum MA:</span>
              <span>&nbsp;</span>
              <a v-if="getDioceseNormDataUrl(location.diocese)" :href="getDioceseNormDataUrl(location.diocese)" target="_blank">{{ location.diocese }}</a>
              <span v-else>{{ location.diocese}}</span>
            </div>
          </div>
        </ContentCard>

        <!-- Orders -->
        <ContentCard title="Orden">
          <div class="flex flex-col">
            <div class="flex items-start lg:items-center" :class="{'mb-2': i < detail.orders.length - 1}" v-for="(order, i) in detail.orders" :key="i">
              <div>
                <div class="order-icon border-2 border-gray-300 rounded-full p-4">
                  <img class="" :src="getOrderIconPath(order.name)" :alt="order.name + ' Icon'">
                </div>
              </div>
              <div class="ml-4">
                <span>{{order.name}}</span> <span>({{order.from}}&ndash;{{order.to}})</span>
              </div>
            </div>
          </div>
        </ContentCard>

        <ContentCard title="Bemerkung" v-if="detail.note">
          <p>{{detail.note ? detail.note : '-'}}</p>
        </ContentCard>

        <!-- Literature -->
        <template v-if="literature">
          <ContentCard :title="literatureSection" v-for="(literatureSection, i) in Object.keys(literature)" :key="'l'+i">
            <div class="justify-start mb-2 last:mb-0" v-for="(literatureItem, k) in literature[literatureSection]" :key="k">
              <template v-if="literatureItem.url">
                <a :href="literatureItem.url" target="_blank">
                  {{literatureItem.fullTitle}}
                </a><span v-if="literatureItem.detail">, {{literatureItem.detail}}</span>
              </template>
              <template v-else>
                {{literatureItem.fullTitle}}<span v-if="literatureItem.detail">, {{literatureItem.detail}}</span>
              </template>
            </div>
          </ContentCard>
        </template>

        <!-- External Urls -->
        <template v-if="externalUrls">
          <ContentCard :title="urlSection" v-for="(urlSection, i) in Object.keys(externalUrls)" :key="'eu'+i">
            <div class="justify-start mb-2 last:mb-0 lg:mb-0" v-for="(urlItem, k) in externalUrls[urlSection]" :key="k">
              <span class="block lg:inline">{{urlItem.label}}</span> <a :href="urlItem.url" target="_blank">{{urlItem.value}}</a>
            </div>
          </ContentCard>
        </template>

        <!-- GS Volumes -->
        <template v-if="detail.gsVolumes && detail.gsVolumes.length > 0">
          <ContentCard title="Publikation der Germania Sacra zu dieser Institution">
            <div class="justify-start mb-4 last:mb-0" v-for="(gsVolume, i) in detail.gsVolumes" :key="'v'+i">
              <a v-if="gsVolume.url" :href="gsVolume.url" target="_blank">{{gsVolume.label}}</a>
              <span v-else class="block lg:inline">{{gsVolume.label}}</span>
            </div>
          </ContentCard>
        </template>

      <!-- Persons -->
      <ContentCard class="persons" v-if="persons" title="Geistliches Personal">
        <div class="flex flex-col flex-shrink-0 flex-1 rounded overflow-hidden text-gray-500">
          <p class="mb-1">(aus dem <a href="https://personendatenbank.germania-sacra.de" target="_blank">Digitalen Personenregister</a> der Germania Sacra)</p>
          <p class="mb-2">{{detail.personsNote}}</p>
          <Persons :persons="persons" class="flex-1 overflow-hidden"></Persons>
        </div>
      </ContentCard>
    </div>
    <div class="error-container" v-if="error">
      <div v-if="error.code === 500" class="flex flex-col items-center">Es ist ein Problem auf dem Server aufgetreten.
        <Button size="small" plain @click="reload" class="mt-2">Neu laden</Button></div>
      <div v-else>Unbekannter Fehler</div>
    </div>
  </div>
</template>

<script>
import Persons from '@/components/Persons.vue';
import ContentCard from '@/components/ContentCard.vue';
import { imagePaths } from '@/mixins/imagePaths';

export default {
  name: 'MonasteryDetail',
  components: {
    Persons,
    ContentCard,
  },
  data () {
    return {
      gsn: null,
      isCollapsed: false,
      personsTable: false,
      rowIndex: 0,
      disablePrevious: false,
      disableNext: false,
      navigationOffset: 0,
    };
  },
  computed: {
    detail () {
      return this.$store.state.monasteryDetail;
    },
    literature () {
      if (this.detail.literature && this.detail.literature.length > 0) {
        // Map from flat array to grouped array
        const literature = this.detail.literature.reduce((acc, cur) => {
          acc[cur.type] = [...(acc[cur.type] ?? []), cur];
          return acc;
        }, {});

        // Sort alphabetically
        Object.keys(literature).forEach(type => {
          literature[type] = literature[type].sort((a, b) => {
            return a.fullTitle.localeCompare(b.fullTitle);
          });
        });

        return literature;
      }
      return null;
    },
    externalUrls () {
      if (this.detail.externalUrls && this.detail.externalUrls.length > 0) {
        // Map from flat array to grouped array
        return this.detail.externalUrls.reduce((acc, cur) => {
          acc[cur.type] = [...(acc[cur.type] ?? []), cur];
          return acc;
        }, {});
      }
      return null;
    },
    persons () {
      if (this.detail.persons && this.detail.persons.length > 0) {
        return this.detail.persons.reduce((acc, cur) => {
          acc[cur.designation] = [...(acc[cur.designation] ?? []), cur];
          return acc;
        }, {});
      }

      return null;
    },
    loading () {
      return this.$store.state.loadingDetail;
    },
    error () {
      return this.$store.state.errors.detail;
    },
    orderSymbolsMap () {
      return this.$store.state.orderSymbolsMap;
    },
    citeUrl () {
      return 'https://klosterdatenbank.germania-sacra.de/gsn/' + this.gsn;
    },
    today () {
      return new Date().toLocaleDateString('de-DE');
    },
    isMobile () {
      return this.$store.state.isMobile;
    },
    monasteries () {
      return this.$store.state.monasteriesList;
    },
    total () {
      return this.$store.state.monasteriesListTotalNumber;
    },
    limit () {
      return this.$store.state.monasteriesQuery.limit;
    },
    page () {
      return this.$store.state.page;
    },
  },
  watch: {
    $route (to, from) {
      this.gsn = Number(to.params.id);
      this.$store.dispatch('getDetail', this.gsn);
    },
    monasteries () {
      const nextId = this.monasteries[this.rowIndex].gsnId;
      this.$router.push({ path: '/gsn/' + nextId });
    },
  },
  methods: {
    backToList () {
      this.$router.push({ path: '/liste' });
    },
    next (currentId, direction) {
      this.disablePrevious = false;
      this.disableNext = false;
      const index = this.monasteries.findIndex(row => row.gsnId == Number(currentId));
      const nextIndex = index + (1 * direction);
      if (typeof this.monasteries[nextIndex] !== 'undefined') {
        this.validateButtons(nextIndex, this.navigationOffset, this.total);
        const nextId = this.monasteries[nextIndex].gsnId;
        this.$router.push({ path: '/gsn/' + nextId });
      } else {
        // no index in current page, get list items from next page
        this.rowIndex = 0;
        let offset = this.navigationOffset + this.limit;
        let page = this.page + 1;
        if (direction < 1) {
          this.rowIndex = this.limit - 1;
          page = this.page - 1;
          offset = this.navigationOffset - this.limit;
        }
        this.$store.dispatch('setPage', page);
        this.navigationOffset = offset;
        this.$store.dispatch('getMonasteriesList', { offset });
      }
    },
    toggleCollapse () {
      this.isCollapsed = !this.isCollapsed;
      this.$emit('toggle-collapse', this.isCollapsed);
    },
    reload () {
      window.location.reload();
    },
    getOrderIconPath (orderName) {
      return imagePaths.getIcon(this.orderSymbolsMap[orderName]);
    },
    validateButtons (index, offset, total) {
      const isFirst = index === 0 && offset === 0;
      const isLast = index === total - 1 || index + offset === total - 1;
      if (index === -1) this.disablePrevious = this.disableNext = true;
      else if (isFirst || isLast) {
        if (isFirst) this.disablePrevious = true;
        if (isLast) this.disableNext = true;
      }
      else this.disablePrevious = this.disableNext = false;
    },
    getLinkedDataURL (format) {
      return import.meta.env.VITE_APP_BASE_URL_API + '/monastery/' + this.detail.gsnId + '/' + format;
    },
    getDioceseNormDataUrl (dioceseName) {
      const diocese = this.detail.dioceses.find(diocese => {
        return diocese.name === dioceseName
      });
      return diocese?.wiagId ? 'https://wiag-vocab.adw-goe.de/id/' + diocese.wiagId : null;
    },
    renderCoordinates({
      monasteryLocationLatitude,
      monasteryLocationLongitude,
      placeLatitude,
      placeLongitude
    }) {
      if (monasteryLocationLatitude || monasteryLocationLongitude) {
        return `${monasteryLocationLatitude}, ${monasteryLocationLongitude} (standortgenau)`;
      }

      return `${placeLatitude}, ${placeLongitude} (Ortsmittelpunkt)`
    }
  },
  beforeRouteEnter (to, from, next) {
    next(vm => {
      vm.gsn = Number(to.params.id)
      vm.$store.dispatch('getDetail', vm.gsn);
      vm.navigationOffset = vm.limit * (vm.page);
      const index = vm.monasteries.findIndex(row => row.gsnId === vm.gsn);
      vm.validateButtons(index, vm.navigationOffset, vm.total);
    });
  },
  beforeRouteUpdate (to, from, next) {
    this.navigationOffset = this.limit * (this.page);
    const index = this.monasteries.findIndex(row => row.gsnId === Number(to.params.id));
    this.validateButtons(index, this.navigationOffset, this.total);
    next();
  },
};
</script>

<style scoped>
:deep(.el-loading-mask) {
  background: none;
}
.button-collapse {
  left: -20px;
  top: 50%;
  @apply absolute z-10 text-gray-400 text-xl p-0 outline-none border-none;
  @apply py-8 rounded;

}
.button-back {
  @apply self-start ml-2 !important;
  @apply lg:ml-4;


  &:first-child {
    @apply ml-0 !important;
   }

  z-index: 1;
}

.error-container {
  @apply absolute flex items-center justify-center top-0 bottom-0 left-0 right-0 text-gray-400 z-0;
}

.order-icon {
  @apply relative;
  width: 34px;
  height: 34px;
  padding: 6px;
  :deep(img) {
    width: 70%;
    height: 70%;
    @apply absolute;
    left: 50%;
    top: 50%;
    transform: translate(-50%, -50%);
  }
}

.persons {
  :deep(.el-card) {
    background: none;
    @apply p-0;
    @apply lg:p-4;
  }
}
</style>
